// Spieler.java                                     MM 2013
import Tools.IO.*;

/**
 * Spieler,
 * hat einen Namen und im Spiel erhaltene Punkte.
 * @author Monika Meiler
 */
public class Spieler
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Namen.
 */
  private String name = "";

/**
 * Punkte.
 */
  private int punkte = 0;

/* ----------------------------------------------------- */
                                             // Konstruktor
/**
 * Setzt den Namen eines Spielers.
 * @param n Name des Spielers
 */
  public Spieler( String n)
  {
    name = n;
  }

/* ----------------------------------------------------- */
                                             // set-Methode
/**
 * Setzt den Namen eines Spielers.
 * @param n Name des Spielers
 */
  public void setName( String n)
  {
    name = n;
  }

/**
 * Setzt Punkte.
 * @param pkt erhaltene Punkte
 */
  public void setPunkte( int pkt)
  {
    punkte = pkt;
  }

/**
 * Addiert Punkte.
 * @param punkteNeu erhaltene Punkte
 * @return Gesamtpunktezahl
 */
  public int addPunkte( int punkteNeu)
  {
    punkte += punkteNeu;
    return punkte;
  }

/* ----------------------------------------------------- */
                                            // get-Methoden
/**
 * Gibt Namen des Spielers zurueck.
 * @return Spielername
 */
  public String getName()
  {
    return name;
  }

/**
 * Gibt Punkte zurueck.
 * @return Spielerpunkte
 */
  public int getPunkte()
  {
    return punkte;
  }

/* ----------------------------------------------------- */
                                            // Testprogramm
/**
 * Test der Klasse Spieler,
 * Spieler "Anton" erhlt als Punkte
 * die Summe der ersten 99 natuerlichen Zahlen.
 */
  public static void main( String[] args)
  {
// Neuer Spieler
    Spieler anton = new Spieler( "Anton");

// Addition der Punkte
    int anzahl = 100;
    for( int i = 0; i < anzahl; i++)
      anton.addPunkte( i);

// Ausgaben, Gauss: 4950 Punkte
    System.out.println( anton.getName());
    System.out.println( anton.getPunkte());

    System.out.println();

// Eingabe Spieleranzahl
    int anzahlSpieler = IOTools.readInteger
    ( "Wie viel Spieler spielen mit (mindstens 1)? ");

// Spielerfeld
    Spieler[] alleSpieler = new Spieler[ anzahlSpieler];

// Eingabe der Namen
    for( int i = 0; i < alleSpieler.length; i++)
    {
                                           // neuer Spieler
      String name = IOTools.readLine
      ( "Name des " + (i+1) + ". Spielers: ");

      Spieler spieler = new Spieler( name);
      
      alleSpieler[ i] = spieler;
    }

    System.out.println();

// Ausgabe der Namen
    for( int i = 0; i < alleSpieler.length; i++)
    {
                                           // neuer Spieler
      System.out.print
      ( "Name des " + (i+1) + ". Spielers: ");
      System.out.println( alleSpieler[ i].getName());

    }
  }
}