// WettWuerfeln.java                                MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Zwei Standardwuerfel wuerfeln um die Wette.
 * @author Monika Meiler
 */
public class WettWuerfeln
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Standardwuerfel.
 */
  private Wuerfel wuerfelRot = new Wuerfel();

/**
 * Standardwuerfel.
 */
  private Wuerfel wuerfelBlau = new Wuerfel();

/**
 * Augednsumme WuerfelRot.
 */
  private int summeRot = 0;

/**
 * Augednsumme WuerfelBlau.
 */
  private int summeBlau = 0;

/**
 * Rundenanzahl insgesamt.
 */
  private int anzahlRunden = 10;

/* ----------------------------------------------------- */
                                             // Spielaufbau
/**
 * Spiel starten.
 */
  public void starten()
  {
// Erlaeuterung
    System.out.println();
    erlaeuterung();

    System.out.println();
    IOTools.readLine( "Weiter (ENTER) ");

// Spielstart
    char weiter = 'j';
    do
    {
      System.out.println();                        // Spiel
      spielen();

      System.out.println();                   // Auswertung
      auswertung();
                                                  // Weiter
      weiter = IOTools.readChar( "Noch einmal (j/n)? ");
    } while( weiter == 'j');

// Beenden
    System.out.println();
    System.out.println( "Spiel beendet!");
  }

/* ----------------------------------------------------- */
                                                   // Spiel
/**
 * Spielerlaeuterung.
 */
  private void erlaeuterung()
  {
    String str = "Ein roter und ein blauer Wuerfel ";
    str += "wuerfeln " + anzahlRunden;
    str += " x um die Wette.";

    System.out.println( str);
  }

/**
 * Spielen, wuerfeln mit zwei Wuerfel und
 * addieren der Augenzahlen.
 */
  private void spielen()
  {
    int wurf;
    for( int runde = 0; runde < anzahlRunden; runde++)
    {
      System.out.println();
      System.out.println( runde + ". Wurf: ");

      wurf = wuerfelRot.wuerfeln();
      summeRot += wurf;
      System.out.println
      ( "Roter Wuerfel  (" + summeRot + "):\t" + wurf);

      wurf = wuerfelBlau.wuerfeln();
      summeBlau += wurf;
      System.out.println
      ( "Blauer Wuerfel (" + summeBlau + "):\t" + wurf);

    System.out.println();
    IOTools.readLine( "Weiter (ENTER) ");
    }
  }

/**
 * Spielauswertung, Ausgabe der Augensummen.
 */
  private void auswertung()
  {
    String str = "Ergebnis";
    str += "\nRoter Wuerfel:  " + summeRot;
    str += "\nBlauer Wuerfel: " + summeBlau;

    System.out.println( str);
  }

/* ----------------------------------------------------- */
                                                // Programm
/**
 * Programm, erzeugt und startet ein Zweiwuerfelspiel.
 */
  public static void main( String[] args)
  {
// Spiel erzeugen
    ZweiWuerfelSpiel spiel = new ZweiWuerfelSpiel();

// Spiel starten
    spiel.starten();
  }
}
