// WuerfelSpiel.java                                MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Wuerfelspiel, Spiel fuer mindestens zwei Personen.
 * Die Spieler wuerfeln der Reihe nach, gewonnen hat
 * der oder die Spieler mit der groessten Augensumme.
 * @author Monika Meiler
 */
public class WuerfelSpiel
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Alle Spieler.
 */
  private Spieler[] alleSpieler;

/**
 * Standardwuerfel.
 */
  private Wuerfel wuerfel = new Wuerfel();

/**
 * Anzahl der Runden, die zu spielen sind.
 */
  private int anzahlRunden = 10;

/* ----------------------------------------------------- */
                                             // Spielaufbau
/**
 * Spiel starten.
 */
  public void starten()
  {
// Erlaeuterung
    System.out.println();
    erlaeuterung();

    System.out.println();
    IOTools.readLine( "Weiter (ENTER) ");

// Spielstart
    char weiter = 'j';
    do
    {
      // Spiel
      System.out.println();
      spielen();

      // Auswertung
      System.out.println();
      auswertung();

      // Weiter
      weiter = IOTools.readChar( "Noch einmal (j/n)? ");
    } while( weiter == 'j');

// Beenden
    System.out.println();
    System.out.println( "Spiel beendet!");
  }

/* ----------------------------------------------------- */
                                                   // Spiel
/**
 * Spielerlaeuterung.
 */
  private void erlaeuterung()
  {
    String str = "Wuerfelspiel, ";
    str += "Spiel fuer mindestens zwei Personen.\n\n";

    str += "Die Spieler wuerfeln der Reihe nach,\n";
    str += "gewonnen hat der oder die Spieler ";
    str += "mit der groessten Augensumme.";

    System.out.println( str);
  }

/**
 * Eingabe der Spieler, Spielen.
 */
  private void spielen()
  {
// Liest Spieler ein
    int anzahlSpieler = eingabeSpieler();

// Spiel
    if( anzahlSpieler > 0)
    {
      for( int runde = 1; runde <= anzahlRunden; runde++)
      {
        System.out.println();                   // Wuerfeln
        System.out.println( runde + ". Runde:");
        naechsteRunde();

        System.out.println();
        zeigeStand();                         // Spielstand
      }
    }
  }

/**
 * Ermittelt alle Sieger, evtl. auch mehr als einen.
 */
  private void auswertung()
  {
    if( alleSpieler.length > 0)
    {
// maximal erreichte Punktzahl
      int maxPunkte = 0;
      for( int j = 0; j < alleSpieler.length; j++)
        if( alleSpieler[ j].getPunkte() > maxPunkte)
          maxPunkte = alleSpieler[ j].getPunkte();

// Spieler mit maximal erreichter Punktzahl
      String str = "Sieger mit maximaler Punktzahl ";
      str += maxPunkte + ": ";

      for( int j = 0; j < alleSpieler.length; j++)
        if( alleSpieler[ j].getPunkte() == maxPunkte)
          str += alleSpieler[ j].getName() + " ";

      System.out.println( str);
    }
  }

/* ----------------------------------------------------- */
                                        // private-Methoden
/**
 * Liest alle Spieler ein.
 * @return Anzahl der eingegebenen Spieler
 */
  private int eingabeSpieler()
  {
    System.out.println();
                                           // Spieleranzahl
    int anzahlSpieler = IOTools.readInteger
    ( "Wie viel Spieler spielen mit (mindstens 1)? ");

    if( anzahlSpieler > 0)
    {
                                             // Spielerfeld
      alleSpieler = new Spieler[ anzahlSpieler];

      String name;
      for( int i = 0; i < alleSpieler.length; i++)
      {
                                           // neuer Spieler
        name = IOTools.readLine
        ( "Name des " + ( i + 1) + ". Spielers: ");

        alleSpieler[ i] = new Spieler( name);
      }
    }

    return anzahlSpieler;
  }

/**
 * Naechste Runde, alle Spieler Wuerfeln.
 */
  private void naechsteRunde()
  {
    for( int j = 0; j < alleSpieler.length; j++)
    {
      System.out.println();            // naechster Spieler
      IOTools.readLine
      ( alleSpieler[ j].getName() + " (ENTER)");

      int wurf = wuerfel.wuerfeln();            // Wuerfeln
      alleSpieler[ j].addPunkte( wurf);

      for( int k = 0; k < wurf; k++)             // Anzeige
        System.out.print( "* ");
      System.out.println( wurf + " Augen");
    }
  }

/**
 * Anzeigen des Spielstandes.
 */
  private void zeigeStand()
  {
    String str = "";
    for( int j = 0; j < alleSpieler.length; j++)
    {
      str += alleSpieler[ j].getName() + ": ";
      str += alleSpieler[ j].getPunkte() + "\n";
    }
    System.out.println( str);
  }

/* ----------------------------------------------------- */
                                                // Programm
/**
 * Startet ein Wuerfelspiel.
 */
  public static void main( String[] args)
  {
// Wuerfelspiel erzeugen
    WuerfelSpiel wuerfeln = new WuerfelSpiel();

// Wuerfelspiel starten
    wuerfeln.starten();
  }
}
